/*+------------------------------------------------------------------+
                                                      bb - %b.mq4 
                               Copyright  2010, Nondisclosure007 
                                               http://no.link.yet 
                                               
http://www.bollingerbands.com/
http://www.bbforex.com/
//+------------------------------------------------------------------+*/
#property copyright "Copyright  2010, Nondisclosure007"
#property link      "http://no.link.yet"

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 Yellow
#property indicator_color2 Red
#property indicator_color3 Blue
//---- input parameters
extern int       bbPeriod    =          10;
extern int       bbDeviation =           2;
extern int       bbPrice     =           0;
extern int       lookback    =         120;
int windowhandle;
double Bandwidth[],BWMin[],BWMax[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorShortName("Bandwidth - Period="+bbPeriod);   
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,Bandwidth);
   SetIndexLabel(0,"Bandwidth");
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,BWMin);
   SetIndexLabel(1,"BWMin");
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,BWMax);
   SetIndexLabel(2,"BWMax");
   IndicatorDigits(Digits+1);
   windowhandle=WindowFind("Bandwidth - Period="+bbPeriod);
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
 
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   //Bar stuff
   int    counted_bars=IndicatorCounted();
   int limit; 
   double bbUpper, bbLower, bbMiddle;
   if(counted_bars<0) return(-1); 
   limit=Bars-counted_bars-1;
 
   for(int shift=0; shift<limit; shift++)
      {
      bbUpper=iBands(NULL,0,bbPeriod,bbDeviation,0,bbPrice,MODE_UPPER,shift);
      bbLower=iBands(NULL,0,bbPeriod,bbDeviation,0,bbPrice,MODE_LOWER,shift);
      bbMiddle=iMA(NULL,0,bbPeriod,0,MODE_SMA,bbPrice,shift);
      Bandwidth[shift]=((bbUpper-bbLower)/bbMiddle)*100; 
      }
 
   for(int shift2=0; shift2<limit; shift2++)
      {  
      double MinBw=Bandwidth[ArrayMinimum(Bandwidth,lookback,shift2+1)];
      double MaxBw=Bandwidth[ArrayMaximum(Bandwidth,lookback,shift2+1)];
      BWMin[shift2]=(MinBw*0.25)+MinBw;
      BWMax[shift2]=MaxBw;//MaxBw-(MaxBw*0.25);
      }
 
   return(0);
  }
  
/*
      BWMin[shift2]=(MinBw*0.25)+MinBw;
      BWMA[shift2]=(MinBw*2.0)+MinBw;//iMAOnArray(Bandwidth,0,24,0,MODE_SMA,shift2+1);
*/