/*+------------------------------------------------------------------+
                                                      bb - %b.mq4 
                               Copyright  2010, Nondisclosure007 
                                               http://no.link.yet 
                                               
http://www.bollingerbands.com/
http://www.bbforex.com/
//+------------------------------------------------------------------+*/
#property copyright "Copyright  2010, Nondisclosure007"
#property link      "http://no.link.yet"

#property indicator_separate_window
#property indicator_buffers 1

//---- input parameters
extern int       bbPeriod=20;
extern int       bbDeviation=2;
extern int       bbPrice=0;

double PercentB[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorShortName("%b - Period="+bbPeriod+"    ");   
   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,1,Blue);
   IndicatorDigits(Digits+1);
   SetIndexBuffer(0,PercentB);
   SetIndexLabel(0,"%b");
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   //Bar stuff
   int    counted_bars=IndicatorCounted(); int limit; 
   if(counted_bars<0) return(-1); 
   limit=Bars-counted_bars-1;
   for(int shift=0; shift<limit; shift++)
   {
      double bbUpper=iBands(NULL,0,bbPeriod,bbDeviation,0,bbPrice,MODE_UPPER,shift);
      double bbLower=iBands(NULL,0,bbPeriod,bbDeviation,0,bbPrice,MODE_LOWER,shift);
      PercentB[shift]=((Close[shift]-bbLower)/(bbUpper-bbLower))*100.0; 
   }
   return(0);
  }
//+------------------------------------------------------------------+